/*
*	Copyright(c) 2012 - 2022  IntervalZero, Inc.  All rights reserved.
*
*	Module Name:
*		RtNalIGC.c
*
*	Abstract:
*		This solutions shows the framework required for and RTX64 Network Interface Adapter(NIC)
*		driver.
*
*	Environments:
*		Real-time 64-bit Subsystem (supported configurations: RTSSDebug and RTSSRelease)
*
*	THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
*	AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
*	IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
*	ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
*	LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
*	CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
*	SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
*	INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
*	CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
*	ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
*	POSSIBILITY OF SUCH DAMAGE.
*/
    
#include "RtNalIGC.h"

// DllMain: Entry into a dynamic-link library (DLL).  It is called by the system
// when processes and threads are created and terminated, or upon calls to
// LoadLibrary and FreeLibrary.  DllMain must explicitly return TRUE, otherwise
// the RTDLL fails to load.
//
BOOL
RTAPI
DllMain(HINSTANCE hinstDLL,
	DWORD fdwReason,
	LPVOID lpvReserved)
{
	switch (fdwReason)
	{
	case DLL_PROCESS_ATTACH:
		// Indicates that the DLL is being loaded into the virtual address
		// space of the current process as a result of a call to
		// LoadLibrary (either explicitly or implicitly).
		pGlobals = &g_DrvGlobals;
		memset(pGlobals, 0x00, sizeof(DRV_GLOBALS));
		pGlobals->msgPrefix = "RtNaLIGC: ";
		break;

	case DLL_PROCESS_DETACH:
		// Indicates that the DLL is being unloaded from the virtual address
		// space of the calling process as a result of either a process exit
		// or a call to FreeLibrary (either explicitly or implicitly).
		break;
	}

	return TRUE;
}